from encoder import text_to_signal
from decoder import signal_to_text
from channel import channel

def test_local():
    message = "HelloWorld123 ThisIsATestMessage12345678"
    x, codebook = text_to_signal(message, r=6, Eb=3)
    y = channel(x)
    decoded = signal_to_text(y, codebook, r=6)

    print(f"Original: {message}")
    print(f"Decoded : {decoded}")
    errors = sum(1 for a, b in zip(message, decoded) if a != b)
    print(f"Character errors: {errors}/40")

if __name__ == "__main__":
    test_local()
